<?php

define('Auth_Yadis_CURL_OVERRIDE', 1);
// uprava
if (Tools::isSubmit('SubmitCreateMojeId')) {

    $login = trim(Tools::getValue('openid_identifier'));
    if (empty($login)) {
        $this->errors[] = Tools::displayError('mojeID is required');
    } else {
        require_once './modules/mojeid/common.php';
        $consumer = getConsumer();
        $auth_request = $consumer->begin($login);
        if (!$auth_request) {
            $this->errors[] = Tools::displayError('Autentizace selhala, váš mojeID není platný.');
        } else {

            // https://www.mojeid.cz/files/mojeid/Technicke_podminky_provozu_20140901.pdf
            $attribute = array();
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/email', 2, 1, 'email');
            // Openservis
            // $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/namePerson/friendly', 1, 1, 'nick');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/namePerson/first', 1, 1, 'firstname');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/namePerson/last', 1, 1, 'lastname');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/phone/default', 1, 1, 'phone');
            // openservis
            // $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/web/default', 1, 0, 'web');

            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/birthDate', 1, 0, 'birthday');

            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/contact/status');

            // real delivery address
            // openservis // company chybí, neznám URL
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/ship/company_name', 1, 0, 'delivery_company');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/ship/street', 1, 1, 'street');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/ship/street2', 1, 0, 'street1');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/ship/city', 1, 1, 'city');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/ship/cc', 1, 1, 'country');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/ship/pc', 1, 1, 'postcode');

            /*
                               $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/mail/street', 1, 1, 'street');
                               $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/mail/street2', 1, 0, 'street1');
                               $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/mail/city', 1, 1, 'city');
                               $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/mail/cc', 1, 1, 'country');
                               $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/mail/pc', 1, 1, 'postcode');
                        */
            //delivery address
            /*
                    $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/postalAddress/home', 1, 1, 'street');
                    $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/postalAddressAdditional/home', 1, 0, 'street1');
                    $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/city/home', 1, 1, 'city');
                    $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/country/home', 1, 1, 'country');
                    $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/contact/postalCode/home', 1, 1, 'postcode');
            */
            //invoice address
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://axschema.org/company/name', 1, 0, 'company');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/contact/ident/vat_id', 1, 0, 'vat_id');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/contact/vat', 1, 0, 'vat');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/bill/street', 1, 0, 'i_steet');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/bill/city', 1, 0, 'i_city');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/bill/cc', 1, 0, 'i_country');
            $attribute[] = Auth_OpenID_AX_AttrInfo::make('http://specs.nic.cz/attr/addr/bill/pc', 1, 0, 'i_postcode');




            // Create AX fetch request
            $ax = new Auth_OpenID_AX_FetchRequest();
            // Add attributes to AX fetch request
            foreach ($attribute as $attr) {
                $ax->add($attr);
            }
            // Add AX fetch request to authentication request
            if ($ax) {
                $auth_request->addExtension($ax);
            }
            $policy_uris = null;
            if (isset($_POST['policies'])) {
                $policy_uris = $_POST['policies'];
            }
            $pape_request = new Auth_OpenID_PAPE_Request($policy_uris);
            if ($pape_request) {
                $auth_request->addExtension($pape_request);
            }
            if ($auth_request->shouldSendRedirect()) {
                $redirect_url = $auth_request->redirectURL(getTrustRoot(), getReturnTo());
                // If the redirect URL can't be built, display an error
                // message.
                if (Auth_OpenID::isFailure($redirect_url)) {
                    $this->errors[] = Tools::displayError("Could not redirect to server: " . $redirect_url->message);
                } else {
                    // Send redirect.
                    header("Location: " . $redirect_url);
                }
            } else {
                // Generate form markup and render it.
                $form_id = 'openid_message';
                $form_html = $auth_request->htmlMarkup(getTrustRoot(), getReturnTo(), false, array('id' => $form_id));
                // Display an error if the form markup couldn't be generated;
                // otherwise, render the HTML.
                if (Auth_OpenID::isFailure($form_html)) {
                    $this->errors[] = Tools::displayError("Could not redirect to server: " . $form_html->message);
                } else {
                    print $form_html;
                }
            }
        }
    }
}

if (Tools::isSubmit('fromMojeId')) {


    $levels = array(
        'CONDITIONALLY_IDENTIFIED' => '1. stupeň',
        'IDENTIFIED' => '2. stupeň',
        'VALIDATED' => '3. stupeň'
    );
    error_reporting(E_ALL);
    ini_set("display_errors", 1);
    require_once './modules/mojeid/common.php';
    $chyba = false;
    $exists = false;
    //tady zpracovat finish_auth.php
    $consumer = getConsumer();
    // Complete the authentication process using the server's
    // response.
    $return_to = getReturnTo();
    $response = $consumer->complete($return_to);
    if ($response->status == Auth_OpenID_CANCEL) {
        $this->errors[] = Tools::displayError('Verification cancelled.');
    } else if ($response->status == Auth_OpenID_FAILURE) {
        $this->errors[] = Tools::displayError("OpenID authentication failed: " . $response->message);
    } else if ($response->status == Auth_OpenID_SUCCESS) {
        $ax = new Auth_OpenID_AX_FetchResponse();
        $obj = $ax->fromSuccessResponse($response);
        $level = isset($levels[$obj->data['http://specs.nic.cz/attr/contact/status'][0]]) ?
            (isset($levels[$obj->data['http://specs.nic.cz/attr/contact/status'][0]]) ?
                $levels[$obj->data['http://specs.nic.cz/attr/contact/status'][0]] : 'nedost.') : 'nedost.';
        $email = $obj->data['http://axschema.org/contact/email'][0];
        $res = Db::getInstance()->ExecuteS('SELECT `email`, `id_customer`, `mojeid` FROM `' . _DB_PREFIX_ . 'customer`
				WHERE `email` = \'' . $email . '\'
				AND deleted <> 1');
        /*$login = $obj->data['http://axschema.org/namePerson/friendly'][0];
        if (is_null($login)) $login = Tools::getValue('login');*/
        $login = $_POST['openid_claimed_id'];
        $firstname = $obj->data['http://axschema.org/namePerson/first'][0];
        $lastname = $obj->data['http://axschema.org/namePerson/last'][0];
        $phone = $obj->data['http://axschema.org/contact/phone/default'][0];
        $web = $obj->data['http://axschema.org/contact/web/default'][0];
        $birthday = $obj->data['http://axschema.org/birthDate'][0];
        //delivery address

        // $dStreet = $obj->data['http://axschema.org/contact/postalAddress/home'][0];
//         $dStreet1 = $obj->data['http://axschema.org/contact/postalAddressAdditional/home'][0];
        //      $dCity = $obj->data['http://axschema.org/contact/city/home'][0];
        // $dCity = preg_replace('/[0-9 ]*/', '', $dCity);
        // $dCountry = $obj->data['http://axschema.org/contact/country/home'][0];
//        $dPsc = $obj->data['http://axschema.org/contact/postalCode/home'][0];
        $dStreet = $obj->data['http://specs.nic.cz/attr/addr/ship/street'][0];
        $dStreet1 = $obj->data['http://specs.nic.cz/attr/addr/ship/street2'][0];
        $dCity = $obj->data['http://specs.nic.cz/attr/addr/ship/city'][0];
        //$dCity = preg_replace('/[0-9 ]*/', '', $dCity);
        $dCountry = $obj->data['http://specs.nic.cz/attr/addr/ship/cc'][0];
        $dPsc = $obj->data['http://specs.nic.cz/attr/addr/ship/pc'][0];
        if ($dCountry == 'CZ') $dCountry = 'Czech Republic';
        if ($dCountry == 'SK') $dCountry = 'Slovakia';
        if (!isset($dCountry)) $dCountry = 'Czech Republic';
        $dCompany = $obj->data['http://specs.nic.cz/attr/addr/ship/company_name'][0];


        //invoice address
        $iCompany = $obj->data['http://axschema.org/company/name'][0];
        // Openservis - begin //
        $iic = $obj->data['http://specs.nic.cz/attr/contact/ident/vat_id'][0];
        $idic = $obj->data['http://specs.nic.cz/attr/contact/vat'][0];
        // Openservis - end //

        $iStreet = $obj->data['http://specs.nic.cz/attr/addr/bill/street'][0];
        $iCity = $obj->data['http://specs.nic.cz/attr/addr/bill/city'][0];
        // $iCity = preg_replace('/[0-9 ]*/', '', $iCity);
        $iCountry = $obj->data['http://specs.nic.cz/attr/addr/bill/cc'][0];
        if ($iCountry == 'CZ') $iCountry = 'Czech Republic';
        if ($iCountry == 'SK') $iCountry = 'Slovakia';
        if (!isset($iCountry)) $iCountry = 'Czech Republic';
        $iPsc = $obj->data['http://specs.nic.cz/attr/addr/bill/pc'][0];





        //uzivatel se prihlasil pres mojeID s emailem, ktery jiz je v preste
        if (isset($res[0]['email']) && is_null($res[0]['mojeid'])) {
            //musim updatnout jeho zaznam v DB - pridat mojeid
            $sql = 'UPDATE `' . _DB_PREFIX_ . 'customer` SET `mojeid` = \'' . pSQL($login) . '\'
					, `mojeid_origin` = \'Ano\', `auth_level` = \'' . $level . '\' WHERE `email` = \'' . pSQL($email) . '\'';
            $res[0]['mojeid'] = $login;
            Db::getInstance()->Execute($sql);
            $exists = true;
        }
        if (empty($res)) { //novy uzivatel
            $vars = array('submitAccount' => 1, 'email' => $email, 'passwd' => md5(_COOKIE_KEY_ . $login),
                'firstname' => $firstname, 'lastname' => $lastname, 'customer_firstname' => $firstname,
                'customer_lastname' => $lastname, 'address1' => $dStreet, 'birthday' => $birthday,
                'address2' => $dStreet1, 'postcode' => $dPsc, 'city' => $dCity, 'id_country' => Country::getIdByName(null, $dCountry),
                'phone_mobile' => $phone, 'alias' => 'Delivery address', 'email_create' => 1,
                'back' => 'order.php?step=1', 'customer_privacy' => 1);
            $ch = curl_init('http://' . $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT']
                . __PS_BASE_URI__ . 'index.php?controller=authentication');
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $vars);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            ob_start();
            $r = curl_exec($ch);
            curl_close($ch);

            ob_end_clean();

            Db::getInstance()->Execute('UPDATE `' . _DB_PREFIX_ . 'customer` SET `mojeid` = \'' . pSQL($login) . '\'
					, `mojeid_origin` = \'Ano\', `auth_level` = \'' . $level . '\' WHERE `email` = \'' . pSQL($email) . '\'');

            if (isset($iCountry) && isset($iCity) && isset($iStreet)) {
                $user = Db::getInstance()->getRow('SELECT id_customer FROM `' . _DB_PREFIX_ . 'customer`
						WHERE `mojeid` = \'' . pSQL($login) . '\' AND deleted <> 1
						AND `email` = \'' . pSQL($email) . '\'');
                if (isset($iCountry) && isset($iCity) && isset($iStreet) && isset($iPsc)) {
                    $iAddress = new Address();
                    $iAddress->id_customer = $user['id_customer'];
                    if (isset($iCompany)) $iAddress->company = $iCompany;
                    // openservis - begin //
                    if (isset($iic)) $iAddress->dni = $iic;
                    if (isset($idic)) $iAddress->vat_number = $idic;
                    // openservis - end //
                    if (isset($iStreet)) $iAddress->address1 = $iStreet;
                    if (isset($iCity)) $iAddress->city = $iCity;
                    if ($iCountry == 'CZ') $iCountry = 'Czech Republic';
                    if ($iCountry == 'SK') $iCountry = 'Slovakia';
                    if (!isset($iCountry)) $iCountry = 'Czech Republic';
                    if (isset($iCountry)) $iAddress->id_country = Country::getIdByName(null, $iCountry);
                    if (isset($iPsc)) $iAddress->postcode = $iPsc;
                    if (isset($firstname)) $iAddress->firstname = $firstname;
                    if (isset($lastname)) $iAddress->lastname = $lastname;
                    if (isset($phone)) $iAddress->phone_mobile = $phone;
                    $iAddress->alias = 'Invoice address';
                    $iAddress->save();
                }
            }


            /* Openservis delivery - begin */
            if (isset($dCountry) && isset($dCity) && isset($dStreet)) {

                $user = Db::getInstance()->getRow('SELECT id_customer FROM `' . _DB_PREFIX_ . 'customer`
						WHERE `mojeid` = \'' . pSQL($login) . '\' AND deleted <> 1
						AND `email` = \'' . pSQL($email) . '\'');
                if (isset($dCountry) && isset($dCity) && isset($dStreet) && isset($dPsc)) {

                    $dAddress = new Address();
                    $dAddress->id_customer = $user['id_customer'];
                    if (isset($dCompany)) $dAddress->company = $dCompany;
                    if (isset($dStreet)) $dAddress->address1 = $dStreet;
                    if (isset($dCity)) $dAddress->city = $dCity;
                    if ($dCountry == 'CZ') $dCountry = 'Czech Republic';
                    if ($dCountry == 'SK') $dCountry = 'Slovakia';
                    if (!isset($dCountry)) $dCountry = 'Czech Republic';
                    if (isset($dCountry)) $dAddress->id_country = Country::getIdByName(null, $dCountry);
                    if (isset($dPsc)) $dAddress->postcode = $dPsc;
                    if (isset($firstname)) $dAddress->firstname = $firstname;
                    if (isset($lastname)) $dAddress->lastname = $lastname;
                    if (isset($phone)) $dAddress->phone_mobile = $phone;
                    $dAddress->alias = 'Delivery address';
                    $dAddress->save();
                }
            }
            /* Openservis delivery - end */

            $v = Db::getInstance()->getRow('SELECT id_customer FROM `' . _DB_PREFIX_ . 'customer`
					WHERE `mojeid` = \'' . pSQL($login) . '\' AND deleted <> 1
					AND `email` = \'' . pSQL($email) . '\'');
            if (!$v) {
                $chyba = true;
                $this->errors[] = Tools::displayError('V mojeID formuláři musíte zaškrtnout všechny požadované údaje (označené hvězdičkou). Prosíme o   přihlášení.');
            }
        } else { //update stavajici uzivatele
            $invAddr = false;
            Db::getInstance()->Execute('UPDATE `' . _DB_PREFIX_ . 'customer` SET `auth_level` = \'' . $level . '\'
					WHERE `email` = \'' . pSQL($email) . '\'');
            $customer = new Customer($res[0]['id_customer']);
            if ($birthday) $customer->birthday = $birthday;
            if ($firstname) $customer->firstname = $firstname;
            if ($lastname) $customer->lastname = $lastname;
            $customer->save();
            $addresses = $customer->getAddresses(intval(Configuration::get('PS_LANG_DEFAULT')));
            foreach ($addresses as $address) {
                if ($address['alias'] == 'Delivery address') {
                    $dlvrAddr = true;
                    $dAddress = new Address($address['id_address']);
                    if (isset($dCompany)) $dAddress->company = $dCompany;
                    if (isset($dStreet)) $dAddress->address1 = $dStreet;
                    if (isset($dStreet1)) $dAddress->address2 = $dStreet1;
                    if (isset($dCity)) $dAddress->city = $dCity;
                    if (isset($dCountry)) $dAddress->id_country = Country::getIdByName(null, $dCountry);
                    if (isset($firstname)) $dAddress->firstname = $firstname;
                    if (isset($lastname)) $dAddress->lastname = $lastname;
                    if (isset($dPsc)) $dAddress->postcode = $dPsc;
                    if (isset($phone)) $dAddress->phone_mobile = $phone;
                    $dAddress->save();
                }
                if ($address['alias'] == 'Invoice address') {
                    $invAddr = true;
                    $iAddress = new Address($address['id_address']);
                    if (isset($iCompany)) $iAddress->company = $iCompany;
                    if (isset($iic)) $iAddress->dni = $iic;
                    if (isset($idic)) $iAddress->vat_number = $idic;
                    if (isset($iStreet)) $iAddress->address1 = $iStreet;
                    if (isset($iCity)) $iAddress->city = $iCity;
                    if (isset($iCompany)) $iAddress->company = $iCompany;
                    if (isset($iCountry)) $iAddress->id_country = Country::getIdByName(null, $iCountry);
                    if (isset($firstname)) $iAddress->firstname = $firstname;
                    if (isset($lastname)) $iAddress->lastname = $lastname;
                    if (isset($iPsc)) $iAddress->postcode = $iPsc;
                    if (isset($phone)) $iAddress->phone_mobile = $phone;
                    $iAddress->save();
                }
            }
            if (!$invAddr) {
                if (isset($iCountry) && isset($iCity) && isset($iStreet) && isset($iPsc)) {
                    $iAddress = new Address();
                    if (isset($iCompany)) $iAddress->company = $iCompany;
                    if (isset($iic)) $iAddress->dni = $iic;
                    if (isset($idic)) $iAddress->vat_number = $idic;
                    if (isset($iStreet)) $iAddress->address1 = $iStreet;
                    if (isset($iCity)) $iAddress->city = $iCity;
                    if (isset($iCompany)) $iAddress->company = $iCompany;
                    if (isset($iCountry)) $iAddress->id_country = Country::getIdByName(null, $iCountry);
                    if (isset($firstname)) $iAddress->firstname = $firstname;
                    if (isset($lastname)) $iAddress->lastname = $lastname;
                    if (isset($iPsc)) $iAddress->postcode = $iPsc;
                    if (isset($phone)) $iAddress->phone_mobile = $phone;
                    $iAddress->alias = 'Invoice address';
                    $iAddress->id_customer = $res[0]['id_customer'];
                    $iAddress->save();
                }
            }


            if (!$dlvrAddr) {
                $dAddress = new Address();
                $dAddress->id_customer = $user['id_customer'];
                if (isset($dCompany)) $dAddress->company = $dCompany;
                if (isset($dic)) $dAddress->dni = $dic;
                if (isset($ddic)) $dAddress->vat_number = $ddic;
                if (isset($dStreet)) $dAddress->address1 = $dStreet;
                if (isset($dCity)) $dAddress->city = $dCity;
                if ($dCountry == 'CZ') $dCountry = 'Czech Republic';
                if ($dCountry == 'SK') $dCountry = 'Slovakia';
                if (!isset($dCountry)) $dCountry = 'Czech Republic';
                if (isset($dCountry)) $dAddress->id_country = Country::getIdByName(null, $dCountry);
                if (isset($dPsc)) $dAddress->postcode = $dPsc;
                if (isset($firstname)) $dAddress->firstname = $firstname;
                if (isset($lastname)) $dAddress->lastname = $lastname;
                if ($phone) $dAddress->phone_mobile = $phone;
                $dAddress->alias = 'Delivery address';
                $dAddress->save();
            }


        }
        if ($exists === true) {
            if (empty($email))
                $this->errors[] = Tools::displayError('e-mail address is required');
            elseif (!Validate::isEmail($email))
                $this->errors[] = Tools::displayError('invalid e-mail address');
            else {
                $customer = new Customer();
                $authentication = $customer->getByEmail(trim($email));
                if (!$authentication OR !$customer->id) {
                    /* Handle brute force attacks */
                    sleep(1);
                    $this->errors[] = Tools::displayError('Authentication failed');
                } else {
                    $this->context->cookie->id_customer = (int)($customer->id);
                    $this->context->cookie->customer_lastname = $customer->lastname;
                    $this->context->cookie->customer_firstname = $customer->firstname;
                    $this->context->cookie->logged = 1;
                    $this->context->cookie->is_guest = $customer->isGuest();
                    $this->context->cookie->passwd = $customer->passwd;
                    $this->context->cookie->email = $customer->email;
                    if (Configuration::get('PS_CART_FOLLOWING') AND (empty($this->context->cookie->id_cart) OR Cart::getNbProducts($this->context->cookie->id_cart) == 0))
                        $this->context->cookie->id_cart = (int)(Cart::lastNoneOrderedCart((int)($customer->id)));
                    /* Update cart address */
                    $this->context->cart->id_carrier = 0;
                    $this->context->cart->id_address_delivery = Address::getFirstCustomerAddressId((int)($customer->id));
                    $this->context->cart->id_address_invoice = Address::getFirstCustomerAddressId((int)($customer->id));
                    //$this->context->cart->update();
                    Tools::redirect('my-account.php');
                }
            }
        }
        if (!$chyba) {
            if (empty($email))
                $this->errors[] = Tools::displayError('e-mail address is required');
            elseif (!Validate::isEmail($email))
                $this->errors[] = Tools::displayError('invalid e-mail address');
            else {
                $customer = new Customer();
                $authentication = $customer->getByEmail(trim($email));
                if (!$authentication OR !$customer->id) {
                    /* Handle brute force attacks */
                    sleep(1);
                    $this->errors[] = Tools::displayError('Authentication failed');
                } else {
                    $this->context->cookie->id_customer = (int)($customer->id);
                    $this->context->cookie->customer_lastname = $customer->lastname;
                    $this->context->cookie->customer_firstname = $customer->firstname;
                    $this->context->cookie->logged = 1;
                    $this->context->cookie->is_guest = $customer->isGuest();
                    $this->context->cookie->passwd = $customer->passwd;
                    $this->context->cookie->email = $customer->email;
                    if (Configuration::get('PS_CART_FOLLOWING') AND (empty($this->context->cookie->id_cart) OR Cart::getNbProducts($this->context->cookie->id_cart) == 0))
                        $this->context->cookie->id_cart = (int)(Cart::lastNoneOrderedCart((int)($customer->id)));
                    /* Update cart address */
                    $this->context->cart->id_carrier = 0;
                    $this->context->cart->id_address_delivery = Address::getFirstCustomerAddressId((int)($customer->id));
                    $this->context->cart->id_address_invoice = Address::getFirstCustomerAddressId((int)($customer->id));
                    //$this->context->cart->update();
                    Tools::redirect('my-account.php');
                }
            }
        }
    } else {
        $this->errors[] = Tools::displayError('Unknown error');
    }
}

